
Fontsize = 20;
set(0,'DefaultAxesFontSize',Fontsize)

figure(1);
clf
subplot(2,2,1);
plot(time, state_sim(:,1),'-bo', 'linewidth', 2, 'MarkerSize', 8); hold on
plot(time(end-1)+Ts*[0:N], output.x(:,1),'bx', 'linewidth', 1, 'MarkerSize', 8); 
plot([time(end-1) time(end-1)], [-1 1], 'k');
for i = 1:N
    out = outs{i};
    plot(time(end-1)+Ts*(i-1)+Ts*[0:size(out,2)-1]./size(out,2), out(1,:),'-b', 'linewidth', 1);
end
xlabel('time(s)')
ylabel('x1')
% grid on;
ylim([-1 1])
xlim([time(end)-T/2 time(end)+T])

subplot(2,2,2);
plot(time, state_sim(:,2), '-bo', 'linewidth', 2, 'MarkerSize', 8); hold on
plot(time(end-1)+Ts*[0:N], output.x(:,2), 'bx', 'linewidth', 1, 'MarkerSize', 8); 
plot([time(end-1) time(end-1)], [-1 1], 'k');
for i = 1:N
    out = outs{i};
    plot(time(end-1)+Ts*(i-1)+Ts*[0:size(out,2)-1]./size(out,2), out(2,:),'-b', 'linewidth', 1);
end
xlabel('time(s)')
ylabel('x2')
% grid on;
ylim([-1 1])
xlim([time(end)-T/2 time(end)+T])

subplot(2,2,3:4);
stairs(time(1:end-1), controls_MPC, '-ro', 'linewidth', 2, 'MarkerSize', 8); hold on
stairs([time(end-1) time(end)], [controls_MPC(end) controls_MPC(end)], '-ro', 'linewidth', 2, 'MarkerSize', 8);
stairs(time(end-1)+Ts*[0:N-1], output.u, '--rx', 'linewidth', 1, 'MarkerSize', 8);
plot([time(end-1) time(end-1)], [-1 1], 'k');
xlabel('time(s)')
ylabel('u')
% grid on;
ylim([-1 1])
xlim([time(end)-T/2 time(end)+T])


if( nextTime == Te ) 
    D = 0.8;
    suptitle(['-- Disturbance to system state 2 of size: ' num2str(D) '! --'])
    state_sim(end,2) = state_sim(end,2) + D; 
elseif( nextTime == Te+Ts ) 
    suptitle(['-- Disturbance to system state 2 of size: ' num2str(D) '! --'])
else
    suptitle(['Closed-loop NMPC simulation (current time: ' num2str(time(end),'%2.1f') 's)'])
end